var EcoMailzHelper = 
{   
getGlobalProperty:function(propertyName)
{       
    return browser.i18n.getMessage(propertyName);
},   
arrayToBase64String:function(ab)
{
    var dView = new Uint8Array(ab);   //Get a byte view        
    var arr = Array.prototype.slice.call(dView); //Create a normal array        

    var arr1 = arr.map(function(item){        
        return String.fromCharCode(item);    //Convert
    });

    return window.btoa(arr1.join(''));   //Form a string
},

base64StringToArray:function(s) 
{
    let asciiString = atob(s);
    return new Uint8Array([...asciiString].map(char => char.charCodeAt(0)));
},
    
asciiToUint8Array:function(str)
{
    var chars = [];
    for (var i = 0; i < str.length; ++i)
        chars.push(str.charCodeAt(i));
    
    return new Uint8Array(chars);
},

convertBufferToHexString:function(buffer) 
{
  var hexCodes = [];
  var view = new DataView(buffer);
  for (var i = 0; i < view.byteLength; i += 4) {
    // Using getUint32 reduces the number of iterations needed (we process 4 bytes each time)
    var value = view.getUint32(i)
    // toString(16) will give the hex representation of the number without padding
    var stringValue = value.toString(16)
    // We use concatenation and slice for padding
    var padding = '00000000'
    var paddedValue = (padding + stringValue).slice(-padding.length)
    hexCodes.push(paddedValue);
  }

  // Join all the hex strings into one
  return hexCodes.join("");
},
convertObjectToMap:function(obj)
{
    var mp = new Map();
    
    Object.keys ( obj ). forEach (k => { mp.set(k, obj[k]) });
    
    return mp;
},

stringToBoolean:function(str)
{
    switch(str.toLowerCase().trim()){
        case "true": case "yes": case "1": return true;
        case "false": case "no": case "0": case null: return false;
        default: return Boolean(str);
    }
}
}




